<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>
        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-card-section>
            <div
              class="text-body2 q-mb-sm"
            >
              <translate>What is the frequency of manure or compost distribution on this plot?</translate>
            </div>
            <q-select
              v-model="storeManureDistribution"
              :options="visioneManureDistributions"
              filled
            />
          </q-card-section>

          <template v-if="askManureDetails">
            <q-card-section>
              <div
                class="text-body2 q-mb-sm"
              >
                <translate>Which manure / compost did you use last year ?</translate>
              </div>
              <q-select
                :model-value="fertilizationData.organic_fertilizer"
                :options="visioneOrganicFertilizersWithResidualEffect"
                option-label="name"
                filled
                clearable
                :loading="isLoadingOrganicFertilizers"
                @update:model-value="onFertilizerInput"
              />
            </q-card-section>
            <q-card-section>
              <div
                class="text-body2 q-mb-sm"
              >
                <span
                  v-translate="{chemicalElements: chemicalElementsHTML}"
                  render-html="true"
                >
                  Concentration (by weight) of %{chemicalElements}:
                </span>
              </div>
              <div
                class="row q-col-gutter-sm"
              >
                <div class="col-4">
                  <q-input
                    ref="nitrogen"
                    filled
                    type="number"
                    label="N"
                    suffix="%"
                    v-model="fertilizationData.custom_concentration.n"
                    min="0"
                    max="100"
                    :rules="customInputRules"
                  />
                </div>
                <div class="col-4">
                  <q-input
                    ref="phosphorus"
                    filled
                    type="number"
                    label-slot
                    suffix="%"
                    v-model="fertilizationData.custom_concentration.p2o5"
                    min="0"
                    max="100"
                    :rules="customInputRules"
                  >
                    <template #label>
                      P<sub>2</sub>O<sub>5</sub>
                    </template>
                  </q-input>
                </div>
                <div class="col-4">
                  <q-input
                    ref="potassium"
                    filled
                    type="number"
                    label-slot
                    suffix="%"
                    v-model="fertilizationData.custom_concentration.k2o"
                    min="0"
                    max="100"
                    :rules="customInputRules"
                  >
                    <template #label>
                      K<sub>2</sub>O
                    </template>
                  </q-input>
                </div>
              </div>
            </q-card-section>
            <q-card-section>
              <div
                class="text-body2 q-mb-sm"
              >
                <translate>How much manure / compost fertilizer did you distributed last year ?</translate>
              </div>
              <q-input
                ref="distributed"
                filled
                type="number"
                :suffix="$pgettext('ton', 't')"
                v-model="fertilizationData.dose"
                min="0"
                :rules="customInputRules"
              />
            </q-card-section>
          </template>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              vertical
              align="stretch"
              class="q-pa-none"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'

import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import VisioneMixins, { MANURE_DISTRIBUTIONS, MANURE_DISTRIBUTION_ID_TO_ASK_DETAILS_FOR } from 'src/pages/fieldbook/fertilization/algorithms/visione/mixins/VisioneMixins'

import queryVisioneOrganicFertilizersWithResidualEffects from 'src/pages/fieldbook/fertilization/algorithms/visione/graphql/queryVisioneOrganicFertilizersWithResidualEffects'

// import featureFlags from 'src/services/feature-flags'
const initialFertilizationData = {
  organic_fertilizer: null,
  custom_concentration: {
    n: null,
    p2o5: null,
    k2o: null
  },
  dose: null
}
export default {
  name: 'VisionePreviousCampaignOrganicFertilizationPage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins, VisioneMixins],
  data () {
    return {
      visioneManureDistributions: MANURE_DISTRIBUTIONS,
      visioneOrganicFertilizersWithResidualEffect: [],
      fertilizationData: initialFertilizationData,
      chemicalElementsHTML: 'N, P<sub>2</sub>O<sub>5</sub> and K<sub>2</sub>O'
    }
  },
  computed: {
    askManureDetails () {
      return this.storeManureDistribution && this.storeManureDistribution.id === MANURE_DISTRIBUTION_ID_TO_ASK_DETAILS_FOR
    },
    canContinue () {
      return this.storeManureDistribution != null && this.storeManureDistribution.id !== MANURE_DISTRIBUTION_ID_TO_ASK_DETAILS_FOR
        ? true
        : (
            this.fertilizationData != null &&
          this.fertilizationData.organic_fertilizer != null &&
          (this.fertilizationData.custom_concentration.n != null || this.fertilizationData.custom_concentration.p2o5 != null || this.fertilizationData.custom_concentration.k2o != null) &&
          this.fertilizationData.dose != null
          )
    },
    customInputRules () {
      return [
        val => !isNaN(val) || `${this.$gettext('Must be a number')}`,
        val => (!!val || this.fertilizationData.fertilizer == null) || `* ${this.$gettext('This field is required')}`,
        val => val >= 0 || `${this.$gettext('Must be positive')}`
      ]
    },
    isLoadingOrganicFertilizers () {
      return this.$apollo.queries.visioneOrganicFertilizersWithResidualEffect.loading
    },
    pageTitle () {
      return this.$gettext('Previous Campaign - Organic Fertilization')
    },
    pageSubTitle () {
      return 'Visione'
    },
    qInputs () {
      return [
        this.$refs.nitrogen,
        this.$refs.phosphorus,
        this.$refs.potassium,
        this.$refs.distributed
      ]
    },
    storeManureDistribution: {
      get () {
        return this.$store.state.fertilizationPlan.parameters?.previous_rotation?.manure_distribution
      },
      set (v) {
        this.updatePreviousRotationParameter('manure_distribution', v)
      }
    },
    storeFertilization: {
      get () {
        return this.$store.state.fertilizationPlan.parameters?.previous_rotation?.fertilization
      },
      set (v) {
        this.updatePreviousRotationParameter('fertilization', v)
      }
    }
    // canDisplayRegisteredFertilizer () {
    //   return featureFlags.canDisplayRegisteredFertilizer()
    // }
  },
  apollo: {
    visioneOrganicFertilizersWithResidualEffect: {
      query: queryVisioneOrganicFertilizersWithResidualEffects,
      notifyOnNetworkStatusChange: true,
      update (data) {
        if (this.fertilizationData.organic_fertilizer == null) {
          // Select the first fertilizer by default
          this.onFertilizerInput(data.visione__organic_fertilizer[0])
        } else {
          if (data.visione__organic_fertilizer.find(organicFertilizer => organicFertilizer.id === this.fertilizationData.organic_fertilizer.id) == null) {
            // the fertilizer that was previously selected is no longer available
            // notify the user
            this.$q.notify({
              color: 'red',
              message: this.$gettextInterpolate(this.$gettext('The previously selected fertilizer (%{fertilizer}) is no longer available.'), { fertilizer: this.fertilizationData.organic_fertilizer.name })
            })
            // Reset form data
            this.resetFertilizationData()
          }
        }
        return data.visione__organic_fertilizer
      },
      skip () {
        return !this.askManureDetails
      }
    }
  },
  methods: {
    onClickNext () {
      this.$router.push({
        name: 'visioneSoilCharacteristics'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'visionePreviousCampaignResidues'
      })
    },
    onFertilizerInput (fertilizer) {
      this.fertilizationData.organic_fertilizer = fertilizer
      // this.qInputs.forEach(i => i.resetValidation())
      this.fertilizationData.custom_concentration.n = fertilizer.n
      this.fertilizationData.custom_concentration.p2o5 = fertilizer.p2o5
      this.fertilizationData.custom_concentration.k2o = fertilizer.k2o
      this.fertilizationData.dose = null
    },
    resetFertilizationData () {
      this.fertilizationData = initialFertilizationData
    },
    updateStoreBeforeLeave () {
      if (this.storeManureDistribution?.id !== MANURE_DISTRIBUTION_ID_TO_ASK_DETAILS_FOR) {
        this.resetFertilizationData()
        this.storeFertilization = null
      } else {
        this.storeFertilization = this.fertilizationData
      }
    }
  },
  mounted () {
    // get the fertilizer data from the store if available
    if (this.storeFertilization) {
      // initialize local data with the ones from the store
      this.fertilizationData = JSON.parse(JSON.stringify(this.storeFertilization))
    }
  },
  beforeUnmount () {
    this.updateStoreBeforeLeave()
  }
}
</script>
